# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = ['GroupPartialPermissionsArgs', 'GroupPartialPermissions']

@pulumi.input_type
class GroupPartialPermissionsArgs:
    def __init__(__self__, *,
                 assign_by_default: Optional[pulumi.Input[bool]] = None,
                 group_permissions: Optional[pulumi.Input[Sequence[pulumi.Input['GroupPartialPermissionsGroupPermissionArgs']]]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 sso_mapping_groups: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None):
        """
        The set of arguments for constructing a GroupPartialPermissions resource.
        :param pulumi.Input[bool] assign_by_default: Whether the group will be assigned by default to users. The value needs to be the same for all partial permissions for the same group.
        :param pulumi.Input[Sequence[pulumi.Input['GroupPartialPermissionsGroupPermissionArgs']]] group_permissions: Partial permissions for the group. Those permissions will be added/removed when config is added/removed.
        :param pulumi.Input[str] name: The name of the group. This is used to identify an existing group
        :param pulumi.Input[Sequence[pulumi.Input[str]]] sso_mapping_groups: Mapping groups from the IdP. At the moment the complete list needs to be provided in each partial permission for the same group.
        """
        if assign_by_default is not None:
            pulumi.set(__self__, "assign_by_default", assign_by_default)
        if group_permissions is not None:
            pulumi.set(__self__, "group_permissions", group_permissions)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if sso_mapping_groups is not None:
            pulumi.set(__self__, "sso_mapping_groups", sso_mapping_groups)

    @property
    @pulumi.getter(name="assignByDefault")
    def assign_by_default(self) -> Optional[pulumi.Input[bool]]:
        """
        Whether the group will be assigned by default to users. The value needs to be the same for all partial permissions for the same group.
        """
        return pulumi.get(self, "assign_by_default")

    @assign_by_default.setter
    def assign_by_default(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "assign_by_default", value)

    @property
    @pulumi.getter(name="groupPermissions")
    def group_permissions(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['GroupPartialPermissionsGroupPermissionArgs']]]]:
        """
        Partial permissions for the group. Those permissions will be added/removed when config is added/removed.
        """
        return pulumi.get(self, "group_permissions")

    @group_permissions.setter
    def group_permissions(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['GroupPartialPermissionsGroupPermissionArgs']]]]):
        pulumi.set(self, "group_permissions", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        The name of the group. This is used to identify an existing group
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="ssoMappingGroups")
    def sso_mapping_groups(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        Mapping groups from the IdP. At the moment the complete list needs to be provided in each partial permission for the same group.
        """
        return pulumi.get(self, "sso_mapping_groups")

    @sso_mapping_groups.setter
    def sso_mapping_groups(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "sso_mapping_groups", value)


@pulumi.input_type
class _GroupPartialPermissionsState:
    def __init__(__self__, *,
                 assign_by_default: Optional[pulumi.Input[bool]] = None,
                 group_permissions: Optional[pulumi.Input[Sequence[pulumi.Input['GroupPartialPermissionsGroupPermissionArgs']]]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 sso_mapping_groups: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None):
        """
        Input properties used for looking up and filtering GroupPartialPermissions resources.
        :param pulumi.Input[bool] assign_by_default: Whether the group will be assigned by default to users. The value needs to be the same for all partial permissions for the same group.
        :param pulumi.Input[Sequence[pulumi.Input['GroupPartialPermissionsGroupPermissionArgs']]] group_permissions: Partial permissions for the group. Those permissions will be added/removed when config is added/removed.
        :param pulumi.Input[str] name: The name of the group. This is used to identify an existing group
        :param pulumi.Input[Sequence[pulumi.Input[str]]] sso_mapping_groups: Mapping groups from the IdP. At the moment the complete list needs to be provided in each partial permission for the same group.
        """
        if assign_by_default is not None:
            pulumi.set(__self__, "assign_by_default", assign_by_default)
        if group_permissions is not None:
            pulumi.set(__self__, "group_permissions", group_permissions)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if sso_mapping_groups is not None:
            pulumi.set(__self__, "sso_mapping_groups", sso_mapping_groups)

    @property
    @pulumi.getter(name="assignByDefault")
    def assign_by_default(self) -> Optional[pulumi.Input[bool]]:
        """
        Whether the group will be assigned by default to users. The value needs to be the same for all partial permissions for the same group.
        """
        return pulumi.get(self, "assign_by_default")

    @assign_by_default.setter
    def assign_by_default(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "assign_by_default", value)

    @property
    @pulumi.getter(name="groupPermissions")
    def group_permissions(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['GroupPartialPermissionsGroupPermissionArgs']]]]:
        """
        Partial permissions for the group. Those permissions will be added/removed when config is added/removed.
        """
        return pulumi.get(self, "group_permissions")

    @group_permissions.setter
    def group_permissions(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['GroupPartialPermissionsGroupPermissionArgs']]]]):
        pulumi.set(self, "group_permissions", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        The name of the group. This is used to identify an existing group
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="ssoMappingGroups")
    def sso_mapping_groups(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        Mapping groups from the IdP. At the moment the complete list needs to be provided in each partial permission for the same group.
        """
        return pulumi.get(self, "sso_mapping_groups")

    @sso_mapping_groups.setter
    def sso_mapping_groups(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "sso_mapping_groups", value)


class GroupPartialPermissions(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 assign_by_default: Optional[pulumi.Input[bool]] = None,
                 group_permissions: Optional[pulumi.Input[Sequence[pulumi.Input[Union['GroupPartialPermissionsGroupPermissionArgs', 'GroupPartialPermissionsGroupPermissionArgsDict']]]]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 sso_mapping_groups: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 __props__=None):
        """
        ## Example Usage

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[bool] assign_by_default: Whether the group will be assigned by default to users. The value needs to be the same for all partial permissions for the same group.
        :param pulumi.Input[Sequence[pulumi.Input[Union['GroupPartialPermissionsGroupPermissionArgs', 'GroupPartialPermissionsGroupPermissionArgsDict']]]] group_permissions: Partial permissions for the group. Those permissions will be added/removed when config is added/removed.
        :param pulumi.Input[str] name: The name of the group. This is used to identify an existing group
        :param pulumi.Input[Sequence[pulumi.Input[str]]] sso_mapping_groups: Mapping groups from the IdP. At the moment the complete list needs to be provided in each partial permission for the same group.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: Optional[GroupPartialPermissionsArgs] = None,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        ## Example Usage

        :param str resource_name: The name of the resource.
        :param GroupPartialPermissionsArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(GroupPartialPermissionsArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 assign_by_default: Optional[pulumi.Input[bool]] = None,
                 group_permissions: Optional[pulumi.Input[Sequence[pulumi.Input[Union['GroupPartialPermissionsGroupPermissionArgs', 'GroupPartialPermissionsGroupPermissionArgsDict']]]]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 sso_mapping_groups: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = GroupPartialPermissionsArgs.__new__(GroupPartialPermissionsArgs)

            __props__.__dict__["assign_by_default"] = assign_by_default
            __props__.__dict__["group_permissions"] = group_permissions
            __props__.__dict__["name"] = name
            __props__.__dict__["sso_mapping_groups"] = sso_mapping_groups
        super(GroupPartialPermissions, __self__).__init__(
            'dbtcloud:index/groupPartialPermissions:GroupPartialPermissions',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            assign_by_default: Optional[pulumi.Input[bool]] = None,
            group_permissions: Optional[pulumi.Input[Sequence[pulumi.Input[Union['GroupPartialPermissionsGroupPermissionArgs', 'GroupPartialPermissionsGroupPermissionArgsDict']]]]] = None,
            name: Optional[pulumi.Input[str]] = None,
            sso_mapping_groups: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None) -> 'GroupPartialPermissions':
        """
        Get an existing GroupPartialPermissions resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[bool] assign_by_default: Whether the group will be assigned by default to users. The value needs to be the same for all partial permissions for the same group.
        :param pulumi.Input[Sequence[pulumi.Input[Union['GroupPartialPermissionsGroupPermissionArgs', 'GroupPartialPermissionsGroupPermissionArgsDict']]]] group_permissions: Partial permissions for the group. Those permissions will be added/removed when config is added/removed.
        :param pulumi.Input[str] name: The name of the group. This is used to identify an existing group
        :param pulumi.Input[Sequence[pulumi.Input[str]]] sso_mapping_groups: Mapping groups from the IdP. At the moment the complete list needs to be provided in each partial permission for the same group.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _GroupPartialPermissionsState.__new__(_GroupPartialPermissionsState)

        __props__.__dict__["assign_by_default"] = assign_by_default
        __props__.__dict__["group_permissions"] = group_permissions
        __props__.__dict__["name"] = name
        __props__.__dict__["sso_mapping_groups"] = sso_mapping_groups
        return GroupPartialPermissions(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="assignByDefault")
    def assign_by_default(self) -> pulumi.Output[bool]:
        """
        Whether the group will be assigned by default to users. The value needs to be the same for all partial permissions for the same group.
        """
        return pulumi.get(self, "assign_by_default")

    @property
    @pulumi.getter(name="groupPermissions")
    def group_permissions(self) -> pulumi.Output[Optional[Sequence['outputs.GroupPartialPermissionsGroupPermission']]]:
        """
        Partial permissions for the group. Those permissions will be added/removed when config is added/removed.
        """
        return pulumi.get(self, "group_permissions")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        The name of the group. This is used to identify an existing group
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="ssoMappingGroups")
    def sso_mapping_groups(self) -> pulumi.Output[Sequence[str]]:
        """
        Mapping groups from the IdP. At the moment the complete list needs to be provided in each partial permission for the same group.
        """
        return pulumi.get(self, "sso_mapping_groups")

